ClientCreateClient:
  name: ${file(resource/index.json):client.createClient}
  description: 'create-client lambda with ebased.'
  handler: src/client/handler/create-client.handler
  iamRoleStatementsInherit: true
  iamRoleStatementsName: nsarrode-createClient-putItem
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:PutItem
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
    - Effect: Allow
      Action:
        - dynamodb:GetItem
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
    - Effect: Allow
      Action:
        - sns:Publish
      Resource: 
        - !Ref EventSnsTopic
  events:
    - http:
        method: POST
        path: createClient

ClientGetClient:
  name: ${file(resource/index.json):client.getClient}
  handler: src/client/handler/get-client.handler
  iamRoleStatementsInherit: true
  iamRoleStatementsName: nsarrode-getClient-getItem
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:GetItem
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
  events:
    - http:
        method: GET
        path: getById

ClientGetAllClient:
  name: ${file(resource/index.json):client.getAll}
  handler: src/client/handler/get-all.handler
  iamRoleStatementsInherit: true
  iamRoleStatementsName: nsarrode-getClient-getAll
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:Query
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
    - Effect: Allow
      Action:
        - dynamodb:Query
        - dynamodb:GetItem
      Resource: !Join [ '/', [ !GetAtt CandidatesDynamoTable.Arn, 'index/*' ] ]
    - Effect: Allow
      Action:
        - dynamodb:Query
      Resource:
        - !GetAtt CandidatesDynamoTable.Arn
  events:
    - http:
        method: GET
        path: getAll

ClientDeleteClient:
  name: ${file(resource/index.json):client.delete}
  handler: src/client/handler/client-delete.handler
  iamRoleStatementsInherit: true
  iamRoleStatementsName: nsarrode-getClient-delete
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:GetItem
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
    - Effect: Allow
      Action:
        - dynamodb:UpdateItem
      Resource: 
        - !GetAtt CandidatesDynamoTable.Arn
  events:
    - http:
        method: DELETE
        path: deleteClient